function [team, cc_score] = opt_thresh_forte_hard_cnstrs(W, f_new, g, lbs, ubs, H_lbs, H_ubs,assocJ,gvolJ,Wcut, dist)
%
% (C)2012-13 Syama Sundar Rangapuram, Thomas Buehler and Matthias Hein 
% Machine Learning Group, Saarland University, Germany
% http://www.ml.uni-saarland.de

% optimal thresholding of constraint objective (with subset)
    %[fsort,indsort]=sort(f_new);
    
    sizeJ=size(Wcut,2);
    
    num = length(f_new);
    [fsort,indsort]=sort(f_new);        
    
%     cum_cards = num:-1:1;
%     cum_cards = cum_cards';
    

    %W_sorted=W_comp(index,index);
    %triup=triu(W_sorted);
    %volumes_threshold=cumsum(deg_comp(index));
    %volumes_threshold - 2*cumsum(full(sum(triup)));
    
    dist_sorted = dist(indsort, indsort);
    triup = triu(dist_sorted);
    deg_comp = sum(dist,1);
    volumes_threshold=cumsum(deg_comp(indsort));
    cut_dist = volumes_threshold - 2*cumsum(full(sum(triup)));
    cut_dist = cut_dist';
    cut_dist = [0; cut_dist(1:end-1)];
        
    Wt=W(indsort(1:num-1),indsort(1:num-1));
    Wtu=triu(Wt,1);
    temp=2*sum(Wtu,2)+diag(Wt) +2 * sum(W(indsort(1:num-1),indsort(num:num)),2);
    all_assoc=sum(sum(W(indsort(1:end),indsort(1:end))))-[0;cumsum(temp)];
    all_assoc(all_assoc<0) = 0;
    
    if sizeJ>0    
     	Wcut= Wcut(indsort(1:num),:);
        
        deg_out = 2*sum(Wcut,2);
        cut_term = sum(deg_out) - [0; cumsum(deg_out(1:num-1))];
        
     	%all_assoc=all_assoc+assocJ + 2*cumsum(sum(Wcut,2));
        all_assoc=all_assoc+assocJ +cut_term;
    end
    
    penalty_thresholds = zeros(num, 1);
    for i=1:length(lbs)
        h = H_lbs(:,i);
        shvol = h(indsort);   
        cumvols = sum(shvol) - [0; cumsum(shvol(1:num-1))];
        penalty_thresholds = penalty_thresholds + max(0, lbs(i)-cumvols); 
    end

    for i=1:length(ubs)
        h = H_ubs(:,i);
        shvol = h(indsort);   
        cumvols = sum(shvol) - [0; cumsum(shvol(1:num-1))];
        penalty_thresholds = penalty_thresholds + max(0, cumvols-ubs(i));
    end
    
    penalty_thresholds( penalty_thresholds >0 ) = inf;  % Hard constraint!
    assert( sum(penalty_thresholds<0) == 0 );

    %penalty_thresholds = penalty_thresholds ./ alldens ;
    
      %all_assoc is only the numerator of the actual density and also the
    %denomiator when max problem is converted to min problem!
    %penalty_thresholds = max(0, k1 - cum_cards) + max(0, cum_cards-k2);
    %penalty_thresholds = penalty_thresholds ./ all_assoc ;

    
    %all_assoc=all_assoc./(k2:-1:k1)';
        
	
	%sgvol = g(indsort);
    %cumvols = sum(sgvol) - [0; cumsum(sgvol(1:num-1))] + gvolJ;
     
    vol_dist_sorted = sum(dist_sorted, 2);
    cumvol_dist_sorted = sum(vol_dist_sorted) - [0; cumsum(vol_dist_sorted(1:num-1))];
    
    penalty_thresholds_dist = cumvol_dist_sorted - cut_dist;
    penalty_thresholds_dist( penalty_thresholds_dist > 0) = inf;  % Hard constraint! 
    
    assert( sum(penalty_thresholds_dist<0) == 0 );

    g_tilde = g;        % g_tilde = g+gamma*2*sum(dist,2);
	sgvol_tilde = g_tilde(indsort);
	cumvols_tilde = sum(sgvol_tilde) - [0; cumsum(sgvol_tilde(1:num-1))] + gvolJ;
	cnstr_dens=cumvols_tilde + penalty_thresholds + penalty_thresholds_dist ; %cnstr_dens=cumvols_tilde+ gamma* penalty_thresholds - 2*gamma*cut_dist;
    %cnstr_dens=cumvols_tilde+ gamma* penalty_thresholds + realmax*cut_dist;
    cnstr_dens = cnstr_dens./all_assoc;    
	
%     ix = find(cut_dist==0);
%     [mini, mix] = min(cnstr_dens(ix));
%     ind3 = ix(mix);
    
    %ind3=find(cnstr_dens==min(cnstr_dens), 1);
    
    assert( sum(cnstr_dens<0) == 0 );
    [cc_score, ind3] = min(cnstr_dens);
    
        
%    ind3=find(all_assoc==max(all_assoc));
    %ind3=ind3(1);


    team=zeros(num,1);
    if cc_score < inf
        team(indsort(ind3:end))=true; 
    else cc_score = NaN;
    end
       
end